/*
File: LocalBase.java
Date		Author		Changes
Mar 07 97	Lukasz Beca	Created
*/
 
package webwisdom.tango.main;

import webwisdom.tango.consts.Const;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.CentralServer;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.structures.Registrar;
import netscape.plugin.Plugin;
import webwisdom.tango.structures.ScriptHandle;
import netscape.javascript.JSObject;
import netscape.security.PrivilegeManager;

public class LocalBase extends Plugin {

  private native void runApplication(String path, int AIDpar, int SIDpar, int ATpar, int portpar);
  private native String getServerHost();
  private native int getServerPort();
  private native int getLocalPort();
  
  private ControlApplication ca;
  public  Registrar reg;

  public LocalBase() {
      
    ca = new ControlApplication();
    reg = new Registrar(getLocalPort());

  }
  
  //plug-in interface
  //public void init();
  //public void destroy();

  public void init() {
       
    CentralServer cs;
    LocalApplications apps;
    
    PrivilegeManager.enablePrivilege("30Capabilities");
    
    cs = new CentralServer(new String(getServerHost()), getServerPort());
    apps = new LocalApplications();   
   
    cs.initAssociations(ca, apps);
    ca.initAssociations(this, cs, apps, reg);
    apps.initAssociations(ca, cs);
    reg.initAssociations(ca, apps);
   
  }

  public void destroy() {

    System.out.println("LocalBase: Plug-in destroyed");
    
    ca.terminated();
    ca = null;
    reg = null;

  }


  //interface for ControlApplication
  //public synchronized void startApplication(int AT, int AID, int localport); 
  //public synchronized void startApplication(String path, String filename, String args);


  public synchronized void startApplication(String path, int AID, int SID, int AT, int localport) {
        
    runApplication(path, AID, SID, AT, localport);
    
  }


  //interface for scripts
  //public ScriptHandle addScrit(JSObject window);

  public ScriptHandle addScript(JSObject window, String AIDs, String SIDs, String ATs) {

    return reg.registerScript(window, AIDs, SIDs, ATs);

  }
   
}










